#ifndef LINT
static char *rcsid="$Id: chat.c,v 1.4 2000/01/01 21:23:32 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: chat.c,v $
	Revision 1.4  2000/01/01 21:23:32  crosser
	set user/group, chat responce logging
	
	Revision 1.3  1999/12/29 23:16:54  crosser
	make syslog and debug use %m for error message
	
	Revision 1.2  1999/12/28 16:01:53  crosser
	Move to syslog
	Portability for HP/UX
	
	Revision 1.1.1.1  1999/08/29 22:53:46  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include <string.h>
#include <ctype.h>
#include "lutil.h"
#include "xutil.h"
#include "nodelist.h"
#include "rdconfig.h"

int chat(node*,modem_string*,modem_string*,modem_string*,int,char*);

struct _strlist {
	struct _strlist *next;
	char *string;
};

char *get_modem_string(modem_string*,node*);
char *next_modem_string(node*);
struct _strlist *sel_str(modem_string*,node*);
void tidy_str(struct _strlist *);

void tidy_str(sl)
struct _strlist *sl;
{
	struct _strlist *tmp;

	while (sl)
	{
		tmp=sl->next;
		free(sl->string);
		free(sl);
		sl=tmp;
	}
}

struct _strlist *sel_str(msl,nlent)
modem_string *msl;
node *nlent;
{
	struct _strlist *sl=NULL,*tmp=NULL;
	char *p,*q;

	for (p=get_modem_string(msl,nlent);p;p=next_modem_string(nlent))
	{
		if (sl == NULL)
		{
			sl=(struct _strlist *)
				xmalloc(sizeof(struct _strlist));
			tmp=sl;
		}
		else
		{
			tmp->next=(struct _strlist *)
				xmalloc(sizeof(struct _strlist));
			tmp=tmp->next;
		}
		tmp->next=NULL;
		tmp->string=xmalloc(strlen(p)+1);
		q=tmp->string;
		while (*p)
		{
			if (*p == '\\') switch (*++p)
			{
			case '\0':	p--; break;
			case '\\':	*q++='\\'; break;
			case 'r':	*q++='\r'; break;
			case 'n':	*q++='\n'; break;
			case 't':	*q++='\t'; break;
			case 's':	*q++=' '; break;
			case ' ':	*q++=' '; break;
			case 'b':	*q++='\b'; break;
			}
			else *q++ = *p;
			p++;
		}
		*q='\0';
	}
	return sl;
}

char *tranphone(char*,node*);
char *tranphone(phone,nlent)
char *phone;
node *nlent;
{
	static char trp[32];
	char buf[32];
	char *tf,*p,*q;
	int ln;

	if (phone == NULL) return NULL;
	strncpy(trp,phone,sizeof(trp)-1);
	for (tf=get_modem_string(phonetrans,nlent);tf;
	     tf=next_modem_string(nlent))
	{
		strncpy(buf,tf,sizeof(buf)-1);
		if ((p=strchr(buf,'/'))) *p++='\0';
		else p=buf+strlen(buf);
		while (*p && isspace(*p)) p++;
		q=buf+strlen(buf)-1;
		while (*q && isspace(*q)) *q--='\0';
		q=p+strlen(p)-1;
		while (*q && isspace(*q)) *q--='\0';
		ln=strlen(buf);
		if (strncmp(phone,buf,ln) == 0)
		{
			strcpy(trp,p);
			strncat(trp,phone+ln,sizeof(trp)-strlen(q)-1);
			break;
		}
	}
	return trp;
}

int send_str(char *,char*,node*);
int send_str(str,phone,nlent)
char *str,*phone;
node *nlent;
{
	char *p;

	p=str;
	debug(18,"send_str \"%s\"",str);
	syslog(LOG_INFO,"chat send \"%s\"",str);
	while (*p)
	{
		if (*p == '\\') switch (*++p)
		{
		case '\0':	p--; break;
		case '\\':	putchar('\\'); break;
		case 'r':	putchar('\r'); break;
		case 'n':	putchar('\n'); break;
		case 't':	putchar('\t'); break;
		case 'b':	putchar('\b'); break;
		case 's':	putchar(' '); break;
		case ' ':	putchar(' '); break;
		case 'd':	sleep(1); break;
		case 'p':	usleep(250000L); break;
		case 'D':	if (phone) fputs(phone,stdout); break;
		case 'T':	if (phone) fputs(tranphone(phone,nlent),stdout); break;
		default:	putchar(*p); break;
		}
		else putchar(*p);
		p++;
	}
	if (ferror(stdout))
	{
		syslog(LOG_ERR,"send_str error: %m");
		return 1;
	}
	else return 0;
}

static int expired=0;

void almhdl(int);
void almhdl(sig)
int sig;
{
	expired=1;
	debug(18,"timeout");
	return;
}

int expect_str(struct _strlist *,struct _strlist *,int);
int expect_str(succs,errs,timeout)
struct _strlist *succs,*errs;
int timeout;
{
	int maxl,l,i,rc,dptr,deol;
	char *buf,dbuf[64];
	struct _strlist *ts;
	int matched=0,smatch=0,ematch=0,ioerror=0;

	maxl=0;
	for (ts=errs;ts;ts=ts->next) 
		if ((l=strlen(ts->string)) > maxl)
			maxl=l;
	for (ts=succs;ts;ts=ts->next) 
		if ((l=strlen(ts->string)) > maxl)
			maxl=l;
	buf=xmalloc(maxl+1);
	memset(buf,0,maxl+1);

	expired=0;
	signal(SIGALRM,almhdl);
	alarm(timeout);
	dptr=0;
	while (!matched && !expired && !ioerror && !feof(stdin))
	{
		char cbuf;

		for (i=0;i<maxl;i++) buf[i]=buf[i+1];
		rc=read(0,&cbuf,1);
		buf[maxl-1]=cbuf;
		if (rc != 1)
		{
			syslog(LOG_ERR,"chat got read return %d: %m",rc);
			ioerror=1;
		}
		if ((dptr > 1) && (cbuf != '\n') && (cbuf != '\r') &&
		    ((dbuf[dptr-1] == '\n') || (dbuf[dptr-1] == '\r'))) deol=1;
		else deol=0;
		if (ioerror || expired || (dptr >= (sizeof(dbuf)-1)) || deol) {
			dbuf[dptr]='\0';
			dptr=0;
			syslog(LOG_INFO,"chat read \"%s\"",
				printable(dbuf,dptr));
		}
		dbuf[dptr++]=cbuf;
		if (expired) debug(18,"chat got TIMEOUT");
		else debug(18,"chat got '%s'",
			printablec(cbuf));
		for (ts=errs;ts && !matched;ts=ts->next)
		if (strcmp(ts->string,buf+maxl-strlen(ts->string)) == 0)
		{
			matched=1;
			ematch=1;
			syslog(LOG_INFO,"chat abort");
		}
		for (ts=succs;ts && !matched;ts=ts->next)
		if (strcmp(ts->string,buf+maxl-strlen(ts->string)) == 0)
		{
			matched=1;
			smatch=1;
			syslog(LOG_INFO,"chat continue");
		}
		if (expired) syslog(LOG_INFO,"chat got timeout, aborting");
		else
		if (ferror(stdin)) syslog(LOG_INFO,"chat got error, aborting");
		if (feof(stdin)) syslog(LOG_ERR,"chat got EOF, aborting");
	}
	alarm(0);
	signal(SIGALRM,SIG_DFL);
	if (dptr) {
		dbuf[dptr]='\0';
		syslog(LOG_INFO,"chat read \"%s\"",
			printable(dbuf,dptr));
	}

	rc=!(matched && smatch);
	free(buf);
	return rc;
}

int chat(nlent,send,success,error,timeout,phone)
node *nlent;
modem_string *send;
modem_string *success;
modem_string *error;
int timeout;
char *phone;
{
	char *sends;
	struct _strlist *succs=NULL, *errs=NULL;
	int rc;

	if ((sends=get_modem_string(send,nlent)) == NULL)
	{
		syslog(LOG_ERR,"chat cannot find appropriate send string");
		return 1;
	}
	if ((success) && ((succs=sel_str(success,nlent)) == NULL))
	{
		syslog(LOG_ERR,"chat cannot find appropriate expect string");
		return 1;
	}
	if ((error) && ((errs=sel_str(error,nlent)) == NULL))
	{
		tidy_str(succs);
		syslog(LOG_ERR,"chat cannot find appropriate error string");
		return 1;
	}

	rc=send_str(sends,phone,nlent);
	if ((rc == 0) && (errs) && (succs)) 
		rc=expect_str(succs,errs,timeout);

	tidy_str(succs);
	tidy_str(errs);
	return rc;
}
