#ifndef LINT
static char *rcsid="$Id: filelist.c,v 1.4 1999/12/29 23:16:54 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: filelist.c,v $
	Revision 1.4  1999/12/29 23:16:54  crosser
	make syslog and debug use %m for error message
	
	Revision 1.3  1999/12/28 16:01:53  crosser
	Move to syslog
	Portability for HP/UX
	
	Revision 1.2  1999/09/25 21:20:32  crosser
	Changed "dosoutbound" to "subst" after the patch by
	Antuan Avdioukhine <antuan@eltex.ru> (but reworked).
	
	Revision 1.1.1.1  1999/08/29 22:53:46  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <limits.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <ctype.h>
#include <errno.h>
#include "xutil.h"
#include "lutil.h"
#include "bwrite.h"
#include "session.h"
#include "ftn.h"
#include "rdconfig.h"

#ifndef PATH_MAX
#define PATH_MAX 512
#endif

#define LEAVE 0
#define TFS 1
#define KFS 2
#define DSF 3

extern int master;
int made_request;

extern FILE *openpkt(FILE *,faddr*,char);
extern char *pktname(faddr*,char);
extern char *floname(faddr*,char);
extern char *reqname(faddr*,char);
extern char *splname(faddr*,char);
extern unsigned INT32 sequencer(void);
extern char *subst_dos2unix(char*,char*,int);

static char *tmpkname(void);
static char *tmpkname(void)
{
	static char buf[16];
	sprintf(buf,"%08lx.pkt",(unsigned long)sequencer());
	return buf;
}

static char *xtodos(char*); /* return a _new_copy_ like xstrcpy() */
static char *xtodos(orig)
char *orig;
{
	int i;
	char buf[8+1+3+1],*copy,*p,*q,*r;

	if (orig == NULL) return NULL;

	if ((remote_flags & SESSION_FNC) == 0)
	{
		debug(12,"No filename conversion for \"%s\"",S(orig));
		return xstrcpy(orig);
	}

	copy=xstrcpy(orig);
	if ((p=strrchr(copy,'/'))) p++;
	else p=copy;

	if (strcmp(q=copy+strlen(copy)-strlen(".tar.gz"),".tar.gz") == 0)
	{
		*q='\0';
		q="tgz";
	}
	else if (strcmp(q=copy+strlen(copy)-strlen(".tar.z"),".tar.z") == 0)
	{
		*q='\0';
		q="tgz";
	}
	else if (strcmp(q=copy+strlen(copy)-strlen(".tar.Z"),".tar.Z") == 0)
	{
		*q='\0';
		q="taz";
	}
	else if ((q=strrchr(p,'.'))) *q++='\0';
	else q=NULL;

	r=buf;
	for (i=0;(i<8) && (*p);i++,p++,r++)
	switch (*p)
	{
	case '.':
	case '\\':	*r='_'; break;
	default:	*r=toupper(*p);
	}
	if (q)
	{
		*r++='.';
		for (i=0;(i<3) && (*q);i++,q++,r++)
		switch (*q)
		{
		case '.':
		case '\\':	*r='_'; break;
		default:	*r=toupper(*q);
		}
	}
	*r++='\0';

	debug(12,"name \"%s\" converted to \"%s\"",S(orig),S(buf));

	free(copy);
	return xstrcpy(buf);
}

void add_list(file_list**,char*,char*,int,off_t,FILE*,int);
void add_list(lst,local,remote,disposition,floff,flofp,toend)
file_list **lst;
char *local;
char *remote;
int disposition;
off_t floff;
FILE *flofp;
int toend;
{
	file_list **tmpl;
	file_list *tmp;

	debug(12,"add_list(\"%s\",\"%s\",%d,%s)",
		S(local),S(remote),disposition,toend?"to end":"to beg");
	if (toend) for (tmpl=lst;*tmpl;tmpl=&((*tmpl)->next));
	else tmpl=&tmp;
	*tmpl=(file_list*)xmalloc(sizeof(file_list));
	if (toend)
	{
		(*tmpl)->next=NULL;
	}
	else
	{
		(*tmpl)->next=*lst;
		*lst=*tmpl;
	}
	(*tmpl)->local=xstrcpy(local);
	(*tmpl)->remote=xtodos(remote);
	(*tmpl)->disposition=disposition;
	(*tmpl)->floff=floff;
	(*tmpl)->flofp=flofp;
	return;
}

static void check_flo(file_list**,char*);
static void check_flo(lst,nm)
file_list **lst;
char *nm;
{
	FILE *fp;
	off_t off;
	struct flock fl;
	char buf[PATH_MAX],buf2[PATH_MAX],*p,*q;
	int disposition;
	struct stat stbuf;

	debug(12,"check_flo(\"%s\")",S(nm));
	if ((fp=fopen(nm,"r+")) == NULL)
	{
		debug(12,"no flo file");
		return;
	}
	fl.l_type=F_RDLCK;
	fl.l_whence=0;
	fl.l_start=0L;
	fl.l_len=0L;
	if (fcntl(fileno(fp),F_SETLK,&fl) != 0)
	{
		if (errno != EAGAIN)
			syslog(LOG_ERR,"cannot read-lock \"%s\": %m",S(nm));
		else debug(12,"flo file busy: %m");
		fclose(fp);
		return;
	}
	if (stat(nm,&stbuf) != 0)
	{
		syslog(LOG_ERR,"cannot access \"%s\": %m",S(nm));
		fclose(fp);
		return;
	}

	while (!feof(fp) && !ferror(fp))
	{
		off=ftell(fp);
		if (fgets(buf,sizeof(buf)-1,fp) == NULL) continue;
		if (buf[0] == '~') continue; /* skip sent files */
		if (*(p=buf+strlen(buf)-1) == '\n') *p--='\0';
		if (*p == '\r') *p='\0';
		switch (buf[0])
		{
		case '#':	p=buf+1; disposition=TFS; break;
		case '-':
		case '^':	p=buf+1; disposition=KFS; break;
		case '@':	p=buf+1; disposition=LEAVE; break;
		case 0:		continue;
		default:	p=buf; disposition=LEAVE; break;
		}
		p=subst_dos2unix(p,buf2,sizeof(buf2));
		if ((q=strrchr(p,'/'))) q++;
		else q=p;
		add_list(lst,p,q,disposition,off,fp,1);
	}

	add_list(lst,nm,NULL,KFS,0L,fp,1);

	/* here, we leave .flo file open, it will be closed by */
	/* execute_disposition */

	return;
}

file_list *create_filelist(al,fl,create)
fa_list *al;
char *fl;
int create;
{
	file_list *st=NULL,*tmpf;
	fa_list *tmpa;
	char flavor;
	char *nm;
	char tmpreq[13];
	struct stat stbuf;
	int packets=0;
	FILE *fp;

	debug(12,"create_filelist(%s,\"%s\",%d)",
		al?ascfnode(al->addr,0x1f):"<none>",
		S(fl),create);
	made_request=0;
	while ((flavor=*fl++))
	for (tmpa=al;tmpa;tmpa=tmpa->next)
	{
		if (flavor == 'o')
		{
			nm=splname(tmpa->addr,flavor);
			if ((fp=fopen(nm,"w"))) fclose(fp);
			if ((nm != NULL) && (stat(nm,&stbuf) == 0))
			{
				add_list(&st,nm,NULL,DSF,0L,NULL,1);
			}
		}

		nm=pktname(tmpa->addr,flavor);
		if ((nm != NULL) && (stat(nm,&stbuf) == 0))
		{
			packets++;
			add_list(&st,nm,tmpkname(),KFS,0L,NULL,1);
		}

		nm=floname(tmpa->addr,flavor);
		check_flo(&st,nm);

		if ((session_flags & SESSION_WAZOO) &&
		    (master || ((session_flags & SESSION_IFNA) == 0)))
		if (flavor == 'o') /* we don't distinguish flavoured reqs */
		{
			nm=reqname(tmpa->addr,flavor);
			if ((nm != NULL) && (stat(nm,&stbuf) == 0))
			{
				sprintf(tmpreq,"%04X%04X.REQ",
					tmpa->addr->net,tmpa->addr->node);
				add_list(&st,nm,tmpreq,DSF,0L,NULL,1);
				made_request=1;
			}
		}
	}

	if (((st == NULL) && (create > 1)) ||
	    ((st != NULL) && (packets == 0) && (create > 0)))
	{
		debug(12,"create packet for %s",ascfnode(al->addr,0x1f));
		if ((fp=openpkt(NULL,al->addr,'o')))
		{
			iwrite(0,fp);
			fclose(fp);
		}
		add_list(&st,pktname(al->addr,'o'),tmpkname(),KFS,0L,NULL,0);
	}

	for (tmpf=st;tmpf;tmpf=tmpf->next)
	debug(12,"flist: \"%s\" -> \"%s\" dsp:%d flofp:%lu floff:%lu",
		S(tmpf->local),S(tmpf->remote),tmpf->disposition,
		tmpf->flofp,tmpf->floff);

	return st;
}

void tidy_filelist(fl,dsf)
file_list *fl;
int dsf;
{
	file_list *tmp;

	for (tmp=fl;fl;fl=tmp)
	{
		tmp=fl->next;
		if (dsf && (fl->disposition == DSF))
		{
			debug(12,"removing sent file \"%s\"",S(fl->local));
			if (unlink(fl->local) != 0)
			{
				if (errno == ENOENT)
					debug(12,"cannot unlink nonexistent file \"%s\"",
						S(fl->local));
				else
					syslog(LOG_ERR,"cannot unlink file \"%s\": %m",
						S(fl->local));
			}
		}
		if (fl->local) free(fl->local);
		if (fl->remote) free(fl->remote);
		else if (fl->flofp) fclose(fl->flofp);
		free(fl);
	}
	return;
}

void execute_disposition(fl)
file_list *fl;
{
	FILE *fp=NULL;
	char *nm;
	char tpl='~';

	nm=fl->local;
	if ((fl->flofp) && (fl->floff != -1))
	{
		if (fseek(fl->flofp,fl->floff,0) == 0)
		{
			if (fwrite(&tpl,1,1,fl->flofp) != 1)
				syslog(LOG_ERR,"error writing '~' to .flo at %lu: %m",
					fl->floff);
			fflush(fl->flofp);
#ifdef HAVE_FSYNC
			fsync(fileno(fl->flofp));
#endif
		}
		else syslog(LOG_ERR,"error seeking in .flo to %lu: %m",fl->floff);
	}
	switch (fl->disposition)
	{
	case DSF:
	case LEAVE:	debug(12,"leaving sent file \"%s\"",S(nm));
			break;
	case TFS:	debug(12,"truncating sent file \"%s\"",S(nm));
			if ((fp=fopen(nm,"w"))) fclose(fp);
			else syslog(LOG_ERR,"cannot truncate file \"%s\": %m",S(nm));
			break;
	case KFS:	debug(12,"removing sent file \"%s\"",S(nm));
			if (unlink(nm) != 0)
			{
				if (errno == ENOENT)
					debug(12,"cannot unlink nonexistent file \"%s\"",
						S(nm));
				else
					syslog(LOG_ERR,"cannot unlink file \"%s\": %m",
						S(nm));
			}
			break;
	default:	syslog(LOG_ERR,"execute_disposition: unknown disp %d for \"%s\"",
				fl->disposition,S(nm));
			break;
	}
	return;
}
