%token NUMBER PHSTR TIMESTR ADDRSTR IDENT SPEED PHONE TIME ADDRESS DOW ANY WK WE SUN MON TUE WED THU FRI SAT EQ NE GT GE LT LE LB RB AND OR NOT XOR COMMA ASTERISK AROP LOGOP

%{
#ifndef LINT
static char *rcsid_y="$Id: flagexp.y,v 1.2 2000/04/01 21:26:40 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: flagexp.y,v $
	Revision 1.2  2000/04/01 21:26:40  crosser
	experiments with Txy
	better treating of msgids/replyids
	
	Revision 1.1.1.1  1999/08/29 22:53:46  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include "xutil.h"
#include "lutil.h"
#include "nodelist.h"

static int logic(int,int,int);
static int match(int);
static int checkspeed(int,int);
static int checkphone(void);

node *nodebuf;
int result;
struct tm *gnow;
struct tm *lnow;
%}

%%
fullline	: expression
			{debug(13,"fulline: return %d",$1);result=$1;}
		;
expression	: elemexp
			{debug(13,"elem.expr %d",$1);$$ = $1;}
		| NOT expression
			{debug(13,"not.expr %d",$2);$$ = !($2);}
		| expression LOGOP expression
			{debug(13,"log.expr %d %d %d",$1,$2,$3);$$ = logic($1,$2,$3);}
		| LB expression RB
			{debug(13,"backeted.expr %d",$2);$$ = $2;}
		;
elemexp		: flag
			{debug(13,"flag %d",$1);$$ = match($1);}
		| SPEED AROP NUMBER
			{debug(13,"speed on num %d %d",$2,$3);$$ = checkspeed($2,$3);}
		| PHONE PHSTR
			{debug(13,"phone num %d",$2);$$ = checkphone();}
		| PHONE NUMBER
			{debug(13,"phone num %d",$2);$$ = checkphone();}
		| TIME timestring
			{debug(13,"time %d",$2);$$ = $2;}
		| ADDRESS ADDRSTR
			{debug(13,"address %d",$2);$$ = $2;}
		;
flag		: IDENT
			{debug(13,"ident %d",$1);$$ = $1;}
		;
timestring	: TIMESTR
			{debug(13,"timelem %d",$1);$$ = $1;}
		| TIMESTR COMMA timestring
			{debug(13,"log.expr %d %d %d",$1,OR,$3);$$ = logic($1,OR,$3);}
%%

#include "flaglex.c"

int match(fl)
int fl;
{
	int i;

	debug(13,"match: %d",fl);
	if (fl == -1)
	{
		for (i=0;(i<MAXUFLAGS) && (nodebuf->uflags[i]);i++)
			if (strcasecmp(yytext,nodebuf->uflags[i]) == 0) 
				return 1;
		return 0;
	}
	else
	{
		return ((nodebuf->flags & fl) != 0);
	}
}

int logic(e1,op,e2)
int e1,op,e2;
{
	debug(13,"logic: %d %d %d",e1,op,e2);
	switch (op)
	{
	case AND:	return(e1 && e2);
	case OR:	return(e1 || e2);
	case XOR:	return(e1 ^ e2);
	default:	syslog(LOG_ERR,"Parser: internal error: invalid logical operator");
			return 0;
	}
}

int checkspeed(op,speed)
int op,speed;
{
	debug(13,"checkspeed: %d %d",op,speed);
	switch (op)
	{
	case EQ:	return(nodebuf->speed == speed);
	case NE:	return(nodebuf->speed != speed);
	case GT:	return(nodebuf->speed >  speed);
	case GE:	return(nodebuf->speed >= speed);
	case LT:	return(nodebuf->speed <  speed);
	case LE:	return(nodebuf->speed <= speed);
	default:	syslog(LOG_ERR,"Parser: internal error: invalid arithmetic operator");
			return 0;
	}
}

int checkphone(void)
{
	debug(13,"checkphone: \"%s\"",yytext);
	if (nodebuf->phone == NULL) return 0;
	if (strncasecmp(yytext,nodebuf->phone,strlen(yytext)) == 0) return 1;
	else return 0;
}

int flagexp(expr,nl)
char *expr;
node *nl;
{
	time_t tt;
	char *p;

	debug(13,"check expression \"%s\"",expr);
	nodebuf=nl;
	(void)time(&tt);
	gnow=gmtime(&tt);
	lnow=localtime(&tt);
	p=xstrcpy(expr);
	yyPTR=p;
#ifdef FLEX_SCANNER  /* flex requires reinitialization */
	yy_init=1;
#endif
	result=0;
	if ((yyparse()))
	{
		syslog(LOG_ERR,"could not parse expression \"%s\", assume `false'",expr);
		free(p);
		return 0;
	}
	debug(13,"checking result is \"%s\"",result?"true":"false");
	free(p);
	return result;
}

int yyerror(s)
char *s;
{
	syslog(LOG_ERR,"parser error: %s",s);
	return 0;
}
