#ifndef LINT
static char *rcsid="$Id: ifcico.c,v 1.10 2000/04/01 21:26:40 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: ifcico.c,v $
	Revision 1.10  2000/04/01 21:26:40  crosser
	experiments with Txy
	better treating of msgids/replyids
	
	Revision 1.9  2000/01/01 21:23:32  crosser
	set user/group, chat responce logging
	
	Revision 1.8  1999/12/28 16:01:54  crosser
	Move to syslog
	Portability for HP/UX
	
	Revision 1.7  1999/12/28 06:37:28  crosser
	Make TCP slave/daemon and master modes work
	
	Revision 1.6  1999/11/26 18:11:36  crosser
	Tune for sunos4
	
	Revision 1.5  1999/11/09 06:42:42  crosser
	make check easier
	
	Revision 1.4  1999/11/05 06:55:45  crosser
	Work on daemon mode
	
	Revision 1.3  1999/09/12 23:24:30  crosser
	Clean tests
	Work in progress on daemon mode
	
	Revision 1.2  1999/08/30 16:43:15  crosser
	Make the thing at least compile.
	
	Revision 1.1.1.1  1999/08/29 22:53:46  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif
#ifndef OPTARG_DEFINED
#include <getopt.h>
#endif
#ifdef HAVE_CTYPE_H
#include <ctype.h>
#endif
#ifdef HAVE_SYS_STAT_H
#include <sys/stat.h>
#endif
#ifdef HAVE_SYS_WAIT_H
#include <sys/wait.h>
#endif
#ifdef HAVE_SIGNAL_H
#include <signal.h>
#endif
#ifdef HAVE_SYSLOG
#include <syslog.h>
#endif
#include <signal.h>
#include "mygetopt.h"
#include "lutil.h"
#include "xutil.h"
#include "ftn.h"
#include "nodelist.h"
#include "trap.h"
#include "rdconfig.h"

int master=0;
int forcedcalls=0;
char *forcedphone=NULL;
char *forcedline=NULL;
#if defined(HAVE_TCP) || defined(HAVE_TERM)
int daemonmode=0;
char *inetaddr=NULL;
int telnet=0;
#endif
#ifdef NOISEDEBUG
int junklevel=0;
#endif

int call(faddr *);
fa_list *callall(void);
int answer(char *);
#if defined(HAVE_TCP) || defined(HAVE_TERM)
void listentcp(char *);
#endif
void mkdirs(char*);
void setargspace(char**,char**);
void setproctitle(char*);
int daemonw(int);

void usage(void)
{
#ifdef NOISEDEBUG
#if defined(HAVE_TCP) || defined(HAVE_TERM)
	confusage("-r<role> -j<num> -a<inetaddr> -d <node> ...");
#else
	confusage("-r<role> -j<num> -d <node> ...");
#endif
	fprintf(stderr,"-j<num>		damage every <num> byte	[%d]\n",
								junklevel);
#else
#if defined(HAVE_TCP) || defined(HAVE_TERM)
	confusage("-r<role> -a<inetaddr> -d <node> ...");
#else
	confusage("-r<role> -d <node> ...");
#endif
#endif
	fprintf(stderr,"-r 0|1		1 - master, 0 - slave	[0]\n");
	fprintf(stderr,"-n<phone>	forced phone number\n");
	fprintf(stderr,"-l<ttydevice>	forced tty device\n");
#if defined(HAVE_TCP) || defined(HAVE_TERM)
	fprintf(stderr,"-a<inetaddr>	use TCP/IP instead of modem\n");
#endif
	fprintf(stderr,"-T		emulate telnet protocol\n");
	fprintf(stderr,"-d		daemon mode if slave or go to background if master\n");
#if defined(HAVE_TCP) || defined(HAVE_TERM)
	fprintf(stderr,"		or listen on specified socket if slave\n");
#endif
	fprintf(stderr,"  <node>	should be in domain form, e.g. f11.n22.z3\n");
	fprintf(stderr,"		(this implies master mode)\n");
	fprintf(stderr,"\n or: %s tsync|yoohoo|**EMSI_INQC816\n",myname);
	fprintf(stderr,"		(this implies slave mode)\n");
}

int main(argc,argv,envp)
int argc;
char *argv[];
char *envp[];
{
	int c;
	fa_list *callist=NULL,**tmpl;
	faddr *tmp;
	int rc,maxrc,callno=0,succno=0;
	char *answermode=NULL,*p;

	setargspace(argv,envp);

#if defined(HAVE_SYSLOG) && defined(CICOLOG)
	logfacility=CICOLOG;
#endif

	setmyname(argv[0]);
	catch(myname);
#ifdef NOISEDEBUG
#if defined(HAVE_TCP) || defined(HAVE_TERM)
	while ((c=getopt(argc,argv,"j:x:r:n:l:a:TI:dh")) != -1)
#else
	while ((c=getopt(argc,argv,"j:x:r:n:l:I:dh")) != -1)
#endif
#else
#if defined(HAVE_TCP) || defined(HAVE_TERM)
	while ((c=getopt(argc,argv,"x:r:n:l:a:I:dh")) != -1)
#else
	while ((c=getopt(argc,argv,"x:r:n:l:I:dh")) != -1)
#endif
#endif
	if (confopt(c,optarg)) switch (c)
	{
#ifdef NOISEDEBUG
	case 'j':	junklevel=atoi(optarg); break;
#endif
	case 'r':	master=atoi(optarg);
			if ((master != 0) && (master != 1))
			{
				usage();
				exit(1);
			}
			break;
	case 'l':	forcedline=xstrcpy(optarg); break;
	case 'd':	daemonmode=1; break;
#if defined(HAVE_TCP) || defined(HAVE_TERM)
	case 'a':	inetaddr=xstrcpy(optarg); break;
	case 'T':	telnet=1; break;
#endif
	case 'n':	forcedphone=xstrcpy(optarg); break;
	default:	usage(); exit(1);
	}

	if (readconfig())
	{
		fprintf(stderr,"Error getting configuration, aborting\n");
		exit(1);
	}

	maxpsize=0L; /* we want classic packet names here */

	tmpl=&callist;

	while (argv[optind])
	{
		for (p=argv[optind];(*p) && (*p == '*');p++);
		if ((strcasecmp(argv[optind],"tsync") == 0) ||
		    (strcasecmp(argv[optind],"yoohoo") == 0) ||
		    (strncasecmp(p,"EMSI_",5) == 0))
		{
			master=0;
			answermode=xstrcpy(argv[optind]);
			debug(10,"inbound \"%s\" mode",S(answermode));
		}
		else
		{
			debug(8,"callist entry \"%s\"",argv[optind]);
			if ((tmp=parsefaddr(argv[optind])))
			{
				*tmpl=(fa_list *)xmalloc(sizeof(fa_list));
				(*tmpl)->next=NULL;
				(*tmpl)->addr=tmp;
				tmpl=&((*tmpl)->next);
			}
			else syslog(LOG_ERR,"unrecognizable address \"%s\"",argv[optind]);
		}
		optind++;
	}

	if (callist)
	{
		master=1;
		forcedcalls=1;
	}

#ifdef HAVE_SETREUID
	setreuid(uid,uid);
	setregid(gid,gid);
#else
	setgid(gid);
	setegid(gid);
	seteuid(0);
	setuid(uid);
	seteuid(uid);
#endif
	debug(2,"uid=%d, euid=%d, gid=%d, egid=%d",
		getuid(),geteuid(),getgid(),getegid());

	umask(066); /* packets may contain confidential information */

#ifdef HAVE_BSD_SIGNALS
	siginterrupt(SIGALRM,1);
	siginterrupt(SIGPIPE,1);
#endif

	p=xstrcpy(inbound);
	p=xstrcat(p,"/tmp/");
	mkdirs(p);
	free(p);

	maxrc=0;
	if (master) {

		daemonw(!daemonmode);
		if (debugfile) freopen(debugfile,"a",stderr);

		if (callist == NULL) callist=callall();
		for (tmpl=&callist;*tmpl;tmpl=&((*tmpl)->next)) {
			callno++;
			rc=call((*tmpl)->addr);
			syslog(LOG_INFO,"call to %s %s (rc=%d)",
				ascfnode((*tmpl)->addr,0x1f),
				rc?"failed":"successful",rc);
			if (rc > maxrc) maxrc=rc;
			if (rc == 0) succno++;
		}
	} else /* slave */
#if defined(HAVE_TCP) || defined(HAVE_TERM)
		if (daemonmode) {
			daemonw(0);
#ifndef SIGCLD
#define SIGCLD SIGCHLD
#endif
#ifdef HAVE_SIGSET
			sigset(SIGCLD,SIG_IGN);
#else
			signal(SIGCLD,SIG_IGN);
#endif
			if (debugfile) freopen(debugfile,"a",stderr);
			listentcp(inetaddr);
			syslog(LOG_ERR,"listentcp failed, exiting");
		} else
#endif
	{
		setproctitle("-ifcico answering");
		maxrc=answer(answermode);
		callno=1;
		succno=(maxrc == 0);
	}

	if (callno)
		syslog(LOG_INFO,"%d of %d calls, maxrc=%d",succno,callno,maxrc);

	return maxrc;
}
