#ifndef LINT
static char *rcsid="$Id: rdoptions.c,v 1.5 2000/02/01 22:05:33 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: rdoptions.c,v $
	Revision 1.5  2000/02/01 22:05:33  crosser
	janus patch
	Txy flag processing
	
	Revision 1.4  1999/12/28 16:01:54  crosser
	Move to syslog
	Portability for HP/UX
	
	Revision 1.3  1999/08/30 22:56:03  crosser
	dbm checks et al
	
	Revision 1.2  1999/08/30 16:43:15  crosser
	Make the thing at least compile.
	
	Revision 1.1.1.1  1999/08/29 22:53:46  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include "session.h"
#include "xutil.h"
#include "lutil.h"
#include "nodelist.h"
#include "rdconfig.h"

extern char *get_modem_string(modem_string*,node*);
extern char *next_modem_string(node*);

int localoptions;

static struct _ktab {
	char *key;
	int flag;
} ktab[] = {
	{"Call",NOCALL},
	{"Hold",NOHOLD},
	{"PUA",NOPUA},
	{"WaZOO",NOWAZOO},
	{"EMSI",NOEMSI},
	{"Freqs",NOFREQS},
	{"Zmodem",NOZMODEM},
	{"ZedZap",NOZEDZAP},
	{"Janus",NOJANUS},
	{"Hydra",NOHYDRA},
	{"Tcp",NOTCP},
	{"Txy",NOTXY},
	{NULL,0}
};

void rdoptions(node*);
void rdoptions(nlent)
node *nlent;
{
	char *str,*s,*p;
	int i;
	int match;

	localoptions=0;

	for (str=get_modem_string(options,nlent);str;
		str=next_modem_string(nlent))
	{
		s=xstrcpy(str);
		debug(10,"applicable option string: \"%s\"",S(s));
		for (p=strtok(s," \t,");p;p=strtok(NULL," \t,"))
		{
			match=0;
			for (i=0;ktab[i].key;i++)
			{
				if (strcasecmp(ktab[i].key,p) == 0)
				{
					localoptions &= ~(ktab[i].flag);
					match=1;
				}
				else if ((strncasecmp("No",p,2) == 0) &&
				    (strcasecmp(ktab[i].key,p+2) == 0))
				{
					localoptions |= ktab[i].flag;
					match=1;
				}
			}
			if (!match) syslog(LOG_ERR,"illegal option \"%s\" ignored",p);
		}
		free(s);
		debug(10,"new options value: 0x%04x",localoptions);
	}
	s=NULL;
	for (i=0;ktab[i].key;i++)
		{
			s=xstrcat(s," ");
			if (localoptions & ktab[i].flag)
				s=xstrcat(s,"No");
			s=xstrcat(s,ktab[i].key);
		}
	syslog(LOG_INFO,"options:%s",s);
	free(s);
}
