#ifndef LINT
static char *rcsid="$Id: body.c,v 1.2 1999/08/30 16:43:16 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: body.c,v $
	Revision 1.2  1999/08/30 16:43:16  crosser
	Make the thing at least compile.
	
	Revision 1.1.1.1  1999/08/29 22:53:45  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "xutil.h"
#include "lutil.h"
#include "rfcmsg.h"
#include "rdconfig.h"
#include "bwrite.h"
#include "hash.h"

#define TEXTBODY 0
#define NONTEXTBODY 1
#define MESSAGEBODY 2
#define MULTIPARTBODY 3

extern char *bgets(char *,int,FILE *);

void putbody(level,msg,fp,pkt,forbidsplit,hdrsize)
int level;
rfcmsg *msg;
FILE *fp;
FILE *pkt;
int forbidsplit;
int hdrsize;
{
	int splitpart=0;
	int needsplit=0;
	int datasize=0;
	char buf[BUFSIZ];
	char *p;
	int bodytype=TEXTBODY;

	if (level == 0) {
		splitpart=0;
		needsplit=0;
	}

	if (needsplit) {
		fprintf(pkt," * Continuation %d of a split message *\r\r",
				splitpart);
			needsplit=0;
	}
	switch (bodytype) {
	case TEXTBODY:
		if ((p=hdr("X-Body-Start",msg)) && !needsplit) {
			datasize += strlen(p);
			cwrite(p,pkt);
		}
		while (!(needsplit=(!forbidsplit) &&
			(((splitpart &&
			   (datasize > maxmsize)) ||
			  (!splitpart &&
			   ((datasize+hdrsize) > maxmsize))))
								) &&
			(bgets(buf,sizeof(buf)-1,fp)))
		{
			debug(19,"putmessage body %s",buf);
			datasize += strlen(buf);
			cwrite(buf,pkt);
		}
		break;
	}
	if (needsplit) {
		fprintf(pkt,"\r * Message split, to be continued *\r");
		splitpart++;
	}
}
