#ifndef LINT
static char *rcsid="$Id: msgidbm.c,v 1.7 1999/12/29 23:16:54 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: msgidbm.c,v $
	Revision 1.7  1999/12/29 23:16:54  crosser
	make syslog and debug use %m for error message
	
	Revision 1.6  1999/12/28 16:01:54  crosser
	Move to syslog
	Portability for HP/UX
	
	Revision 1.5  1999/11/04 18:34:47  crosser
	better job in finding ndbm
	
	Revision 1.4  1999/11/03 07:06:08  crosser
	Check for ndbm in more places
	
	Revision 1.3  1999/08/30 22:56:03  crosser
	dbm checks et al
	
	Revision 1.2  1999/08/30 16:43:16  crosser
	Make the thing at least compile.
	
	Revision 1.1.1.1  1999/08/29 22:53:45  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif
#ifdef HAVE_SYS_STAT_H
#include <sys/stat.h>
#endif
#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif

#ifdef HAVE_NDBM

#if defined(HAVE_NDBM_H)
#include <ndbm.h>
#elif defined(HAVE_GDBM_NDBM_H)
#include <gdbm/ndbm.h>
#elif defined(HAVE_DB1_NDBM_H)
#include <db1/ndbm.h>
#endif

#include "lutil.h"
#include "xutil.h"
#include "rdconfig.h"
#include "ftn.h"
#include "rfcaddr.h"

static DBM *id_db = NULL;
static int opened = 0;

static int fillidb(void);

static int init(void)
{
	int needbuild;
	struct stat stbuf1;
	char buf[128];
	struct stat stbuf2;
#ifndef HAVE_BSD_DB
	FILE *fp;
#endif

	if ((msgidbm == NULL) || (newslog == NULL)) return -1;
	if (opened == -1) return -1;
	if (stat(newslog,&stbuf1) != 0) return -1;
	if (opened) return 0;
	needbuild=0;
#ifdef HAVE_BSD_DB
	sprintf(buf,"%s.db",msgidbm);
#else
	sprintf(buf,"%s.dir",msgidbm);
#endif
	if ((stat(buf,&stbuf2) != 0) ||
	    (stbuf1.st_mtime > stbuf2.st_mtime))
	{
		syslog(LOG_INFO,"SEEN-BY database rebuild requested");
		needbuild=1;
#ifdef HAVE_BSD_DB
		sprintf(buf,"%s.db",msgidbm);
		unlink(buf);
#else
		sprintf(buf,"%s.dir",msgidbm);
		if ((fp=fopen(buf,"w"))) fclose(fp);
		sprintf(buf,"%s.pag",msgidbm);
		if ((fp=fopen(buf,"w"))) fclose(fp);
#endif
	}
	if ((id_db=dbm_open(msgidbm,O_RDWR | O_CREAT,0600)) == NULL)
	{
		opened = -1;
		return -1;
	}
	opened = 1;

	if (needbuild) return fillidb();
	return 0;
}

static int fillidb(void)
{
	datum key,val;
	char buf[128],*line=NULL,se[16],*seen=NULL,*p,*q,*pe,*id;
	faddr *fa = NULL;
	FILE *fp;
	int n=0;

	if ((fp=fopen(newslog,"r")) == NULL) return -1;

	while (!feof(fp))
	{
		while (((line == NULL) || (line[strlen(line)-1] != '\n')) &&
		       (fgets(buf,sizeof(buf)-1,fp)))
			line=xstrcat(line,buf);
		if (line == NULL) goto nextline;
		pe=line+strlen(line);
		strtok(line," \t\n");	/* Month */
		strtok(NULL," \t\n");	/* Date */
		strtok(NULL," \t\n");	/* Time */
		if ((p=strtok(NULL," \t\n")) != NULL)
		{
			if (*p == '+') /* INN style log */
			{
				p=strtok(NULL," \t\n"); /* skip source host */
			}
			else /* maybe cnews style log? */
			{
				if (((p=strtok(NULL," \t\n")) == NULL) ||
				    (*p != '+')) goto nextline;
			}
		}

		debug(8,"good log entry for %s",p);

		if ((id=strtok(NULL," \t\n")) == NULL) goto nextline;
		/* some witchkraft with char *q,*pe is needed because */
		/* otherwise strtok called from within parsefaddr will */
		/* interfere with strtok in the while cycle */
		q=NULL;
		while ((p=strtok(q," \t\n")))
		{
			if ((q=p+strlen(p)+1) >= pe) q=NULL;
			debug(8,"try parse %s",p);
			if ((fa=parsefaddr(p)))
			{
				sprintf(se,"%s ",
					ascfnode(fa,0x06));
				seen=xstrcat(seen,se);
				debug(8,"new seen: \"%s\"",seen);
				tidy_faddr(fa);
			}
			else debug(8,"unparsable: %s",addrerrstr(addrerror));
		}
		if (seen)
		{
			key.dptr=id;
			key.dsize=strlen(id);
			val.dptr=seen;
			val.dsize=strlen(seen);
			*(seen+strlen(seen)-1) = '\0';
			if (dbm_store(id_db,key,val,0) < 0)
				syslog(LOG_ERR,"cannot store: \"%s\" \"%s\": %m",id,seen);
			else debug(8,"seen-by for \"%s\" is \"%s\"",id,seen);
			n++;
		}
	nextline:
		if (seen) free(seen);
		seen=NULL;
		if (line) free(line);
		line=NULL;
	}
	syslog(LOG_INFO,"SEEN-BY database now contains %d records",n);
	return 0;
}

char *idlookup(msgid)
char *msgid;
{
	datum key,val;

	if (init()) return "";

	debug(8,"idlookup \"%s\"",S(msgid));
	key.dptr=msgid;
	key.dsize=strlen(msgid);
	val=dbm_fetch(id_db,key);
	if (val.dptr) return val.dptr;
	else return "";
}

void close_id_db(void)
{
	if (opened != 1) return;
#ifdef HAVE_DBM_CLOSE
#ifdef HAVE_NDBM
	dbm_close(id_db);
#endif
#endif
	opened=0;
}
#endif
