#ifndef LINT
static char *rcsid="$Id: daemonw.c,v 1.2 1999/12/28 06:37:28 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	This file is partially based on Glibc2's daemon.c
	that was apparently borrowed from BSD sources.
*/

/*-
 * Copyright (c) 1990, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#if defined(LIBC_SCCS) && !defined(lint)
static char sccsid[] = "@(#)daemon.c	8.1 (Berkeley) 6/4/93";
#endif /* LIBC_SCCS and not lint */

/*
	$Log: daemonw.c,v $
	Revision 1.2  1999/12/28 06:37:28  crosser
	Make TCP slave/daemon and master modes work
	
	Revision 1.1  1999/12/12 22:37:19  crosser
	remove strange close()
	
	Revision 1.1  1999/11/03 06:20:52  crosser
	add missing file
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#include <errno.h>
#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif
#ifdef HAVE_SYS_IOCTL_H
#include <sys/ioctl.h>
#endif
#ifdef HAVE_SYS_WAIT_H
#include <sys/wait.h>
#endif
#ifndef WEXITSTATUS
#define WEXITSTATUS(stat_val) ((unsigned)(stat_val) >> 8)
#endif
#ifndef WIFEXITED
#define WIFEXITED(stat_val) (((stat_val) & 255) == 0)
#endif

int
daemonw(dowait)
int dowait;
{
	int fd;
	pid_t pid;

	switch ((pid=fork())) {
	case -1:
		return -1;
	case 0:
		break;
	default:
		if (dowait) {
			int rc,st;
			do {
				rc=wait(&st);
			} while (((rc > 0) && (rc != pid)) ||
				 ((rc == -1) && (errno == EINTR)));
			if (rc == -1) exit(-1);
			if (WIFEXITED(st)) exit(WEXITSTATUS(st));
			else exit(-1);
		} else exit(0);
	}

#ifdef HAVE_SETSID
	if (setsid() == -1) return -1;
#else
#ifdef SETPGRP_VOID
	if (setpgrp() == -1) return -1;
#else
	if (setpgrp(0,0) == -1) return -1;
#endif
#endif
#ifdef TIOCNOTTY
	(void)ioctl(0,TIOCNOTTY,1L);
#endif

	fflush(stdin);
	fflush(stdout);
	fflush(stderr);
	if ((fd = open("/dev/null", O_RDWR, 0)) != -1) {
		(void)dup2(fd,0);
		(void)dup2(fd,1);
		if (fd > 2) (void)close(fd);
	}
	return 0;
}
