#ifndef LINT
static char *rcsid="$Id: execute.c,v 1.3 1999/12/29 23:16:54 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: execute.c,v $
	Revision 1.3  1999/12/29 23:16:54  crosser
	make syslog and debug use %m for error message
	
	Revision 1.2  1999/12/28 16:01:55  crosser
	Move to syslog
	Portability for HP/UX
	
	Revision 1.1.1.1  1999/08/29 22:53:45  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <sys/types.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <sys/wait.h>
#include "lutil.h"

int execute(cmd,file,pkt,in,out,err)
char *cmd,*file,*pkt,*in,*out,*err;
{
	char buf[512];
	char *vector[16];
	int i;
	char *p,*q,*f=file,*k=pkt;
	int pid,status,rc,sverr;

	for (p=cmd,q=buf;(*p) && (q < (buf+sizeof(buf)-1));p++)
	switch (*p)
	{
	case '$':	switch (*(++p))
			{
			case 'f':
			case 'F':
				if (f)
				while ((*f) && (q < (buf+sizeof(buf)-1)))
					*(q++)=*(f++);
				f=file;
				break;
			case 'p':
			case 'P':
				if (k)
				while ((*k) && (q < (buf+sizeof(buf)-1)))
					*(q++)=*(k++);
				k=pkt;
				break;
			default:
				*(q++)='$';
				*(q++)=*p;
				break;
			}
			break;
	case '\\':	*(q++)=*(++p); break;
	default: *(q++)=*p; break;
	}
	*q='\0';
	syslog(LOG_INFO,"Execute: %s",buf);
	i=0;
	vector[i++]=strtok(buf," \t\n");
	while ((vector[i++]=strtok(NULL," \t\n")) && (i<16));
	vector[15]=NULL;
	fflush(stdout);
	fflush(stderr);
	if ((pid=fork()) == 0)
	{
		if (in)
		{
			close(0);
			if (open(in,O_RDONLY) != 0)
			{
				syslog(LOG_ERR,"Reopen of stdin to %s failed: %m",S(in));
				exit(-1);
			}
		}
		if (out)
		{
			close(1);
			if (open(out,O_WRONLY | O_APPEND | O_CREAT,0600) != 1)
			{
				syslog(LOG_ERR,"Reopen of stdout to %s failed: %m",S(out));
				exit(-1);
			}
		}
		if (err)
		{
			close(2);
			if (open(err,O_WRONLY | O_APPEND | O_CREAT,0600) != 2)
			{
				syslog(LOG_ERR,"Reopen of stderr to %s failed: %m",S(err));
				exit(-1);
			}
		}
		rc=execv(vector[0],vector);
		syslog(LOG_ERR,"Exec \"%s\" returned %d: %m",S(vector[0]),rc);
		exit(-1);
	}
	do
	{
		rc=wait(&status);
		sverr=errno;
		debug(2,"Wait returned %d, status %d,%d: %m",
			rc,status>>8,status&0xff);
	}
	while (((rc > 0) && (rc != pid)) || ((rc == -1) && (sverr == EINTR)));
	if (rc == -1)
	{
		syslog(LOG_ERR,"Wait returned %d, status %d,%d: %m",
			rc,status>>8,status&0xff);
		return -1;
	}
	debug(2,"status=%d",status);
	return status;
}
