#ifndef LINT
static char *rcsid="$Id: getheader.c,v 1.3 1999/12/29 23:16:54 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: getheader.c,v $
	Revision 1.3  1999/12/29 23:16:54  crosser
	make syslog and debug use %m for error message
	
	Revision 1.2  1999/12/28 16:01:55  crosser
	Move to syslog
	Portability for HP/UX
	
	Revision 1.1.1.1  1999/08/29 22:53:45  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <stdio.h>
#include <string.h>
#include "lutil.h"
#include "ftn.h"
#include "bread.h"
#include "rdconfig.h"

faddr pktfrom;
char pktpwd[9];

int getheader(f,t,pkt)
faddr *f,*t;
FILE *pkt;
{
	int i,pwdok;
	int capword,capvalid;
	int tome,pointcheck;
	fa_list *al;
	char *p;

	f->domain=NULL;
	f->name=NULL;
	t->domain=NULL;
	t->name=NULL;

	debug(5,"from node: %u",f->node=iread(pkt));
	debug(5,"to   node: %u",t->node=iread(pkt));
	debug(5,"year     : %u",iread(pkt));
	debug(5,"month    : %u",iread(pkt));
	debug(5,"day      : %u",iread(pkt));
	debug(5,"hour     : %u",iread(pkt));
	debug(5,"min      : %u",iread(pkt));
	debug(5,"sec      : %u",iread(pkt));
	debug(5,"rate     : %u",iread(pkt));
	debug(5,"ver      : %u",iread(pkt));
	debug(5,"from net : %u",f->net=iread(pkt));
	debug(5,"to   net : %u",t->net=iread(pkt));
	debug(5,"prodx    : 0x%04x",iread(pkt));
	for (i=0;i<8;i++) pktpwd[i]=getc(pkt);
	pktpwd[8]='\0';
	for (p=pktpwd+7;(p >= pktpwd) && (*p == ' ');p--) *p='\0';
	debug(5,"password : %s",pktpwd);
	if (pktpwd[0]) f->name=pktpwd;
	debug(5,"from zone: %u",f->zone=iread(pkt));
	debug(5,"to   zone: %u",t->zone=iread(pkt));
	debug(5,"filler   : 0x%04x",iread(pkt));
	debug(5,"capvalid : 0x%04x",capvalid=iread(pkt));
	debug(5,"prodcode : 0x%04x",iread(pkt));
	debug(5,"capword  : 0x%04x",capword=iread(pkt));
	debug(5,"from zone: %u",iread(pkt));
	debug(5,"to   zone: %u",iread(pkt));
	debug(5,"from pnt : %u",f->point=iread(pkt));
	debug(5,"to   pnt : %u",t->point=iread(pkt));
	debug(5,"proddata : 0x%08lx",lread(pkt));

	if (feof(pkt) || ferror(pkt)) 
	{
		syslog(LOG_ERR,"Could not read packet header: %m");
		return 2;
	}

	pointcheck=0;
	if (((capword >> 8) == (capvalid & 0xff)) &&
	    ((capvalid >> 8) == (capword & 0xff)))
		pointcheck=(capword & 0x0001);
	else capword=0;

	debug(5,"capword=%04x, pointcheck=%s",capword,pointcheck?"yes":"no");

	pktfrom.name=NULL;
	pktfrom.domain=NULL;
	pktfrom.zone=f->zone;
	pktfrom.net=f->net;
	pktfrom.node=f->node;
	if (pointcheck) pktfrom.point=f->point;
	else pktfrom.point=0;

	tome=0;
	for (al=whoami;al;al=al->next)
	{
	if (((t->zone == 0) || (t->zone == al->addr->zone)) &&
	    (t->net == al->addr->net) &&
	    (t->node == al->addr->node) &&
	    ((!pointcheck) || (t->point == al->addr->point)))
		tome=1;
	}

	pwdok=1;
	for (al=pwlist;al;al=al->next)
	{
	if (((f->zone == 0) || (f->zone == al->addr->zone)) &&
	    (f->net == al->addr->net) &&
	    (f->node == al->addr->node) &&
	    ((!pointcheck) || (f->point == al->addr->point)))
		if (strcasecmp(al->addr->name,pktpwd) != 0)
		{
			pwdok=0;
			syslog(LOG_INFO,"password got \"%s\", expected \"%s\"",
				pktpwd,al->addr->name);
		}
	}

	syslog(LOG_INFO,"packet from node %s",ascfnode(f,0x1f));
	syslog(LOG_INFO,"         to node %s",ascfnode(t,0x1f));

	if (!tome) return 3;
	else if (!pwdok) return 4;
	else return 0;
}
