/*
	$Id: rdconfig.h,v 1.5 2000/04/10 20:44:37 crosser Exp $
*/

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: rdconfig.h,v $
	Revision 1.5  2000/04/10 20:44:37  crosser
	make it compile without syslog
	
	Revision 1.4  2000/01/01 21:23:32  crosser
	set user/group, chat responce logging
	
	Revision 1.3  1999/11/20 14:08:49  crosser
	some configure cleanup
	
	Revision 1.2  1999/09/25 21:20:32  crosser
	Changed "dosoutbound" to "subst" after the patch by
	Antuan Avdioukhine <antuan@eltex.ru> (but reworked).
	
	Revision 1.1.1.1  1999/08/29 22:53:45  crosser
	Ifmail
	
*/

#ifndef _RDCONFIG_H
#define _RDCONFIG_H

#include "ftn.h"

#ifndef AREA_LIST_TYPE
#define AREA_LIST_TYPE
typedef struct _area_list {
	struct _area_list *next;
	char *name;
} area_list;
#endif

typedef struct _modem_string {
	struct _modem_string *next;
	char *line;
	char *expr;
} modem_string;

typedef struct _dom_trans {
	struct _dom_trans *next;
	char *ftndom;
	char *intdom;
} dom_trans;

typedef struct _log_conf {
	struct _log_conf *next;
	int primask;
	char *filename;
} log_conf;

typedef struct _moderator_list {
	struct _moderator_list *next;
	char *prefix;
	char *address;
} moderator_list;

typedef struct _subst_list {
	struct _subst_list *next;
	char *dosp;
	char *unixp;
} subst_list;

extern char *configname;
extern char *nlbase;

extern fa_list *whoami;
extern fa_list *pwlist;
extern fa_list *nllist;

extern dom_trans *domtrans;
extern moderator_list *approve;
extern subst_list *substs;

extern log_conf *logconfig;

extern modem_string *modemport;
extern modem_string *phonetrans;
extern modem_string *modemreset;
extern modem_string *modemdial;
extern modem_string *modemhangup;
extern modem_string *modemok;
extern modem_string *modemconnect;
extern modem_string *modemerror;
extern modem_string *options;

extern area_list *badgroups;

extern long configverbose;
extern long configtime;
extern long maxfsize;
extern long maxpsize;
extern long maxmsize;
extern long speed;
extern long maxgroups;
extern long timeoutconnect;
extern long timeoutreset;
extern long dialdelay;

extern int uid;
extern int gid;

extern char intab[];
extern char outtab[];

extern char *name;
extern char *location;
extern char *sysop;
extern char *phone;
extern char *flags;
extern char *inbound;
extern char *norminbound;
extern char *listinbound;
extern char *protinbound;
extern char *outbound;
extern char *database;
extern char *aliasfile;
extern char *myfqdn;
extern char *sequence;
extern char *sendmail;
extern char *rnews;
extern char *iftoss;
extern char *packer;
extern char *unzip;
extern char *unarj;
extern char *unlzh;
extern char *unarc;
extern char *unzoo;
extern char *unrar;
extern char *areafile;
extern char *newslog;
extern char *msgidbm;
extern char *pubdir;
extern char *magic;
extern char *debugfile;
extern char *routefile;
extern char *nonpacked;
extern char *magicname;

int readconfig(void);
int confopt(int,char*);
void confusage(char*);
#endif
