#ifndef LINT
static char *rcsid="$Id: ulock.c,v 1.3 1999/12/29 23:16:54 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: ulock.c,v $
	Revision 1.3  1999/12/29 23:16:54  crosser
	make syslog and debug use %m for error message
	
	Revision 1.2  1999/12/28 16:01:55  crosser
	Move to syslog
	Portability for HP/UX
	
	Revision 1.1.1.1  1999/08/29 22:53:45  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
#include <signal.h>
#include <sys/stat.h>
#include "lutil.h"

#ifndef LOCKDIR
#define LOCKDIR "/usr/spool/uucp"
#endif

#define LCKPREFIX LOCKDIR"/LCK.."
#define LCKTMP LOCKDIR"/TMP."

int lock(line)
char *line;
{
	pid_t	mypid,rempid=0;
	int	tmppid;
	char	tmpname[256],lckname[256];
	char	*p;
	int	i,rc;
	FILE	*f;

	rc=-1;
	if ((p=strrchr(line,'/')) == NULL) p=line; else p++;
	mypid=getpid();
	sprintf(tmpname,"%s%d",LCKTMP,mypid);
	if ((f=fopen(tmpname,"w")) == NULL)
	{
		debug(4,"lock cannot create %s",tmpname);
		return(-1);
	}
#if defined(ASCII_LOCKFILES)
	fprintf(f,"%10d\n",mypid);
#elif defined(BINARY_LOCKFILES)
	fwrite(&mypid,sizeof(mypid),1,f);
#else
#error Must define ASCII_LOCKFILES or BINARY_LOCKFILES
#endif
	fclose(f);
	chmod(tmpname,0444);
	sprintf(lckname,"%s%s",LCKPREFIX,p);
	p=lckname+strlen(lckname)-1;
	*p=tolower(*p);
	debug(4,"Trying to create %s for %d",lckname,mypid);
	for (i=0; (i++<5) && ((rc=link(tmpname,lckname)) != 0) && 
				(errno == EEXIST); )
	{
		if ((f=fopen(lckname,"r")) == NULL)
		{
			debug(4,"cannot open existing lock file");
		}
		else
		{
#if defined(ASCII_LOCKFILES)
			fscanf(f,"%d",&tmppid);
			rempid=tmppid;
#elif defined(BINARY_LOCKFILES)
			fread(&rempid,sizeof(rempid),1,f);
#endif
			fclose(f);
			debug(4,"lock file read for process %d",rempid);
		}
		if (kill(rempid,0) && (errno ==  ESRCH))
		{
			debug(4,"process inactive, unlink file");
			unlink(lckname);
		}
		else
		{
			debug(4,"process active, sleep a bit");
			sleep(2);
		}
	}
	unlink(tmpname);
	debug(4,"lock result %d (errno %d)",rc,errno);
	return(rc);
}

int ulock(line)
char *line;
{
	pid_t	mypid,rempid;
	int	tmppid;
	char	lckname[256];
	char	*p;
	int	rc;
	FILE	*f;

	rc=-1;
	if ((p=strrchr(line,'/')) == NULL) p=line; else p++;
	mypid=getpid();
	sprintf(lckname,"%s%s",LCKPREFIX,p);
	p=lckname+strlen(lckname)-1;
	*p=tolower(*p);
	if ((f=fopen(lckname,"r")) == NULL)
	{
		syslog(LOG_ERR,"cannot open lock file %s: %m",lckname);
		return rc;
	}
#if defined(ASCII_LOCKFILES)
	fscanf(f,"%d",&tmppid);
	rempid=tmppid;
#elif defined(BINARY_LOCKFILES)
	fread(&rempid,sizeof(rempid),1,f);
#endif
	fclose(f);
	if (rempid ==  mypid)
		rc=unlink(lckname);
	return(rc);
}
